#!/usr/bin/perl -w

use strict;      # force definations for all vars an subroutines
use warnings;    # force check of unset variables in expressions
use diagnostics; # give var/code line number on faults

use File::Basename; # for basename(),



##########################################################################
# sub perl_content_filter($FHANDLE, \$retcntr, \$retmsgs, \%CPSMTPD, \%CPSOCKINFO, \%CPCONFIG, \%CPHEADERS)
# global   -----
# @param   handle $FHANDLE
# @param   int    \$retcntr    - reference int
# @param   string \$retmsgs    - reference string
# @param   HASH   \%CPSMTPD    - reference HASH
#          string $RCPSMTPD->{'HELO'}
#          string $RCPSMTPD->{'FROM'}
#          LIST   @{$RCPSMTPD->{'TO'}}
#          string $RCPSMTPD->{'DATA'}
# @param   HASH   \%CPSOCKINFO - reference HASH
#          string $RCPSOCKINFO->{'sockaddr'}
#          string $RCPSOCKINFO->{'sockhost'}
#          string $RCPSOCKINFO->{'sockport'}
#          string $RCPSOCKINFO->{'peeraddr'}
#          string $RCPSOCKINFO->{'peerhost'}
#          string $RCPSOCKINFO->{'peerport'}
# @param   HASH   \%CPCONFIG   - reference HASH
#          string $RCPCONFIG->{value}
# @param   HASH   \%CPHEADERS  - reference HASH
#          string $RCPHEADERS->{'From'}
#          string $RCPHEADERS->{'To'}
#          string $RCPHEADERS->{'Subject'}
#          string $RCPHEADERS->{'...'}
# @return  int    - # plugin $status==0  plugin returned status in references $retcntr+$retmsgs
# @return  int    - # plugin $status==-1 means DROP message
# @return  int    - # plugin $status==1  means ACCEPT message (messsage counter=0 and stop analyze message)
# @return  int    - # plugin $status==2  plugin modified content or headers
sub perl_content_filter {
	my ($FHANDLE, $Rretcntr, $Rretmsgs, $RCPSMTPD, $RCPSOCKINFO, $RCPCONFIG, $RCPHEADERS)=@_;
	my ($retval, $rcpttoto, $hdrstoto, $key, $val, $found);
	
	$retval=0;
	${$Rretcntr}=0; ${$Rretmsgs}='';
	
	# 2014/04/28: trouble with aliases: RCPT TO==to, not orig_to
	# smtp * * * smtpd [...] -o receive_override_options=no_address_mappings
	# 2014/04/29: troule with aliases again: to=logwatch@somehost RCPTTO=user@otherhost
# 	if (defined($RCPHEADERS->{'To'})) {
# 		
# 		$found=0;
# 		foreach $key (0..$#{$RCPSMTPD->{'TO'}}) {
# 			$rcpttoto=${$RCPSMTPD->{'TO'}}[$key];
# 			if (substr($rcpttoto,0,1) eq '<') { $rcpttoto=substr($rcpttoto, 1); }
# 			$rcpttoto=~s,[\t\s\r\n]+$,,g;
# 			if (substr($rcpttoto,length($rcpttoto)-1,1) eq '>') { $rcpttoto=substr($rcpttoto, 0, length($rcpttoto)-1); }
# 			if (index($RCPHEADERS->{'To'},$rcpttoto)>=0) { $found=1; last; }
# 		}
# 		if ($found==0) {
# 			${$Rretcntr}=${$Rretcntr}+$RCPCONFIG->{'toto_rcptto1notin2hdrstoto_pkts'};
# 			${$Rretmsgs}=${$Rretmsgs}."(RCPTTO not in To) [".join(' ',@{$RCPSMTPD->{'TO'}}).",".$RCPHEADERS->{'To'}."] ";
# 		}
# 		
# 	}
	
	
	
	print($FHANDLE strftime('%Y/%m/%d %H:%M:%S',localtime()).' '.basename(__FILE__).":".__LINE__.":PID[$$]:".(caller(0))[3]."(): status=".${$Rretcntr}.":".${$Rretmsgs}."\n");
	
	return 0;
}



1; # return status for include mode


